//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop

#include "Unit1.h"
#include "PIODA.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "CSPIN"
#pragma resource "*.dfm"

Word wInitialCode,  wRtn ;
Word wTotalBoards;
Word wSelectBoard;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    float fVal;
    int   i, wTtlChs;

    wSelectBoard = (WORD) StrToInt( eSelectBoard->Text );
    if (cbCardType->ItemIndex == 0) wTtlChs = 4;  // PIO-DA4
    if (cbCardType->ItemIndex == 1) wTtlChs = 8;  // PIO-DA8
    if (cbCardType->ItemIndex == 2) wTtlChs = 16; // PIO-DA16

    fVal= StrToFloat( eOut->Text );
    for(i=0; i< wTtlChs; i++)  // Every Channels
    {
       if (cbVoltCur->ItemIndex == 0)  // 0: Voltage Output
            PIODA_CalVoltage( (WORD)wSelectBoard, (Word)i, fVal );
       else                            // 1: Current Output
            PIODA_CalCurrent( (WORD)wSelectBoard, (Word)i, fVal );
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //********************************************************************
    //* NOTICE: call PIODA_DriverInit() to initialize the driver.        *
    //********************************************************************

    wTotalBoards             = 0;
    cbCardType->ItemIndex    = 2;  // 2:PIO-DA16
    //cbCalibration->ItemIndex = 0;  // 0:No
    cbVoltCur->ItemIndex     = 0;  // 0:Voltage Output
    Button1->Caption         = "Output";
    wInitialCode = PIODA_DriverInit();
    if ( wInitialCode != PIODA_NoError )
    {
        ShowMessage( "Driver Initialize Error!!") ;
        Button1->Enabled = False;
        return;
    }
    else
        Button1->Enabled = True;

    wRtn = PIODA_SearchCard( &wTotalBoards, PIO_DA );
    if ( wRtn != PIODA_NoError )
    {
        ShowMessage( "Search Card Error!!\nError Code:" + IntToStr(wRtn) );
        Button1->Enabled = False;
    }

    eSelectBoard->Text  = "0";
    eTotalBoards->Text  = IntToStr(wTotalBoards);
    if ( wTotalBoards < 2 ) eSelectBoard->Enabled = False;
    eSelectBoard->MaxValue = wTotalBoards - 1;
    eSelectBoard->MinValue = 0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
      PIODA_DriverClose();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button2Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::cbVoltCurChange(TObject *Sender)
{
     if ( cbVoltCur->ItemIndex == 0)
          lDesc->Caption = "(+/- 10v)";
     else
          lDesc->Caption = "(0~20mA)";
}
//---------------------------------------------------------------------------

