using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PIODA_Ns;



namespace PIODA_DA
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        ushort wInitialCode;
        ushort wRtn;

        ushort wTotalBoards;
        ushort wSelectBoard;
        ushort wTtlChs;


        private void Form1_Load(object sender, EventArgs e)
        {
            wTotalBoards = 0;
            btnActive.Text = "Output";
            cbCardType.SelectedIndex = 2;
  
            cbVoltCur.SelectedIndex = 0;
            
            //Driver Initial
            
            wInitialCode = PIODA.DriverInit();
            if (wInitialCode != PIODA.NoError)
            {
                MessageBox.Show("Driver Open Error !!!");
                btnActive.Enabled = false;
                return;
            }
            else
            {
                btnActive.Enabled = true;
            }
            wRtn = PIODA.SearchCard(out wTotalBoards, PIODA.ID);
            if ((wRtn != PIODA.NoError))
            {
                MessageBox.Show("Search Card Error!! Error Code:" + Convert.ToString(wRtn));
                btnActive.Enabled = false;
            }
            eTotalBoards.Text = System.Convert.ToString(wTotalBoards);
            nudActive.Minimum = 0;
            nudActive.Maximum = wTotalBoards - 1;
            this.eSelectBoard.Text = Convert.ToString(nudActive.Value);
            //cbxChannel.SelectedIndex = 0;
           
            tbxBaseAddr.Text = Convert.ToString (PIODA.GetBaseAddress(wSelectBoard),16);

                   
        }

        private void cbVoltCur_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbVoltCur.SelectedIndex == 0)
            {
                lDesc.Text = "(+/- 10v)";
            }
            else
            {
                lDesc.Text = "(0~20mA)";
            }

        }

        private void btnActive_Click(object sender, EventArgs e)
        {
            ushort i;

            float fVal;
            wSelectBoard = Convert.ToUInt16(eSelectBoard.Text);
            fVal =Convert.ToSingle(eOut.Text);
            for (i = 0; i <= wTtlChs - 1; i++)
            {                
               
                if (cbVoltCur.SelectedIndex == 0)
                {
                        PIODA.CalVoltage((ushort)wSelectBoard, (ushort)cbxChannel.SelectedIndex, fVal);
                }else{
                        PIODA.CalCurrent((ushort)wSelectBoard, (ushort)cbxChannel.SelectedIndex, fVal);
                }
                
            }
            if (cbVoltCur.SelectedIndex == 0)
            {
                ToolTip1.ToolTipTitle = "How to measure the DA(Voltage) value ?";
                ToolTip1.Show("(+) connect with CN3.pin" + Convert.ToString(cbxChannel.SelectedIndex + 1 +(uint)(cbxChannel.SelectedIndex / 4))+ ",GND(-) connect with CN3.pin10", this.btnActive, 40, 40);
            }
            else
            {
                short curPin;
                if (cbxChannel.SelectedIndex < 8)
                {
                    curPin = (short)(20 + cbxChannel.SelectedIndex + (short)(cbxChannel.SelectedIndex / 4));
                }
                else
                {
                    curPin = (short)(cbxChannel.SelectedIndex + 22);
                }
                ToolTip1.ToolTipTitle = "How to measure the DA(Current) value ?";
                ToolTip1.Show("(+) connect with CN3.pin" + Convert.ToString(curPin) + ",GND(-) connect with CN3.pin29", this.btnActive, 40, 40);
            }

        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            PIODA.DriverClose();
            System.Environment.Exit(0);
        }

        private void cbCardType_SelectedIndexChanged(object sender, EventArgs e)
        {
            short j;
            if (cbCardType.SelectedIndex == 0)
            {
                wTtlChs = 4;
            }
            if (cbCardType.SelectedIndex == 1)
            {
                wTtlChs = 8;
            }
            if (cbCardType.SelectedIndex == 2)
            {
                wTtlChs = 16;
            }
            cbxChannel.Items.Clear();
            for (j = 0; j <= wTtlChs - 1; j++)
            {
                cbxChannel.Items.Add("Channel " + Convert.ToString(j));
            }
            cbxChannel.SelectedIndex = 0;
        }

       
    }
}