using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using controlArray; //namespace ControlArray
using PIODA_Ns;
using System.Collections;//Use P1202_Ns Namespace
using System.Resources;

namespace AD
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        ushort wInitialCode;
        ushort wTotalBoards;
        uint wRtn;
    
        ArrayList mpbo = new ArrayList();
        ArrayList mpbi = new ArrayList();
        bool[] mpbof = new bool[15];

  
        private System.Resources.ResourceManager rm =new System.Resources.ResourceManager("ResourceClient.Images",System.Reflection.Assembly.GetExecutingAssembly()); 
        private void Form1_Load(object sender, EventArgs e)
        {
            ushort i;
            mpbo = ControlArrayUtils.getControlArray(this.gbxOutput  , "pbout", ""); //CreatControlArray 
            mpbi = ControlArrayUtils.getControlArray(this.gbxInput  , "pbin", "");  //CreatControlArray

            for (i = 1; i <= 16; i++)
            {
                ((PictureBox)mpbo[i]).Image =pbGray.Image ;

                ((PictureBox)mpbi[i]).Image =pbGray.Image;

                ((PictureBox)mpbo[i]).SizeMode = PictureBoxSizeMode.StretchImage;
                ((PictureBox)mpbi[i]).SizeMode = PictureBoxSizeMode.StretchImage;

                ((PictureBox)mpbo[i]).Click += new EventHandler(SignOutput); //mpbOutputs Click event
               


            }
            
            //Driver Initial
            wInitialCode = PIODA.DriverInit();
            if (wInitialCode != PIODA.NoError)
            {
                MessageBox.Show("Driver Initial Error !!!");
                this.btnActive.Enabled = false;
                this.tbxTotal.Text = "0";
            }
            wRtn = PIODA.SearchCard(out wTotalBoards, PIODA.ID);
        if (wRtn != PIODA.NoError) 
        {
            MessageBox.Show("Search Card Error!!" );
            btnActive.Enabled = false;
        }
        else{
            tbxTotal.Text = Convert.ToString(wTotalBoards);
            nudActive.Maximum = wTotalBoards - 1;
            nudActive.Minimum = 0;
            tbxBaseAddr.Text = Convert.ToString(PIODA.GetBaseAddress((ushort)nudActive.Value),16);
        }
        tbxOutput.Text = "0";



        }

        private void SignOutput(object sender, System.EventArgs e)
        {
            PictureBox pb = (PictureBox)sender;
            ushort i = Convert.ToUInt16((Convert.ToString(pb.Name)).Remove(0, 5));

            if (((PictureBox)mpbo[i]).Image == pbGray.Image)
            {
                ((PictureBox)mpbo[i]).Image = pbRed.Image;
            }
            else
            {
                ((PictureBox)mpbo[i]).Image = pbGray.Image;
            }

         

            ushort DoVal;
            ushort index;
            DoVal = 0;
            for (index = 1; index <= 16; index++)
            {
                if (((PictureBox)mpbo[index]).Image == pbRed.Image)
                {
                    DoVal = (ushort)(DoVal |(ushort) (1<< (index-1)));
                }
            }
            tbxOutput.Text = Convert.ToString (DoVal,16).ToUpper();
            
        //********************************************************************
        //* NOTICE: call PIODA_Do()  Digital Output                          *
        //*                                                                  *
        //********************************************************************

            PIODA.DO((ushort)nudActive.Value, DoVal);
            tbxOutput.Text = Convert.ToString (DoVal,16);
        }


        private void btnActive_Click(object sender, EventArgs e)
        {
           int i ;
      
   
        if (btnActive.Text =="&Stop") 
        {    timer1.Enabled = false;

            btnExit.Enabled = true;
            btnActive.Text = "&Active";
            btnOutput.Enabled = false;
            btnClear.Enabled = false;
            btnTest.Enabled = false;
            btnOpen.Enabled = false;

            for (i = 1;i<= 16;i++)
            {
                ((PictureBox)mpbo[i]).Enabled  = false;
                ((PictureBox)mpbi[i]).Enabled  = false;
              
            }
            return ;
        }

        btnActive.Text = "&Stop";

        for (i = 1;i<= 16;i++)
        {
                ((PictureBox)mpbo[i]).Enabled  = true;
                ((PictureBox)mpbi[i]).Enabled  = true;
              
        }
        timer1.Enabled = true;
        btnExit.Enabled = false;
        btnOutput.Enabled = true;
        btnClear.Enabled = true;
        btnTest.Enabled = true;
        btnOpen.Enabled = true;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            PIODA.DriverClose();
            Application.Exit();

            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            uint DIVal;
            ushort index;
            PIODA.DI((ushort)nudActive.Value ,out DIVal);
            tbxInput.Text = Convert.ToString(DIVal,16).ToUpper();
            for (index = 1; index <= 16; index++)
            {
                if (System.Convert.ToBoolean(DIVal & (1 << (index - 1))))
                {
                    ((PictureBox)mpbi[index]).Image = pbRed.Image; 
                }
                else
                {
                    ((PictureBox)mpbi[index]).Image = pbGray.Image;
                }
            }
            Application.DoEvents();

        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            //********************************************************************
            //* NOTICE: call PIODA_Do()  Digital Output                          *
            //*                                                                  *
            //********************************************************************
            uint DOVal;
            ushort index;
            DOVal = Convert.ToUInt16(tbxOutput.Text,16);
            PIODA.DO((ushort)nudActive.Value, DOVal);

            for (index = 1; index <= 16; index++)
            {
                if (System.Convert.ToBoolean(DOVal & (1 << (index - 1))))
                {
                    ((PictureBox)mpbo[index]).Image = pbRed.Image;
                }
                else
                {
                    ((PictureBox)mpbo[index]).Image = pbGray.Image;
                }
            }
            Application.DoEvents();
            
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            tbxOutput.Text = "0";
            btnOutput_Click(sender,e);
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            tbxOutput.Text = "FFFF";
            btnOutput_Click(sender, e);
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            uint shiftDOval;
            shiftDOval = 1;
            while (shiftDOval<=0x8000)
            {
                tbxOutput.Text = Convert.ToString(shiftDOval, 16);
                btnOutput_Click(sender, e);
                shiftDOval = shiftDOval * 2;

                Application.DoEvents();
                System.Threading.Thread.Sleep(100);
            }

            btnClear_Click(sender, e);
        }

       
    }
}