using System.Runtime.InteropServices;
namespace PIODA_Ns
{
    public class PIODA
    {
        public const ushort NoError = 0;
        public const ushort DriverOpenError = 1;
        public const ushort DriverNoOpen = 2;
        public const ushort GetDriverVersionError = 3;
        public const ushort InstallIrqError = 4;
        public const ushort ClearuintCountError = 5;
        public const ushort GetuintCountError = 6;
        public const ushort RegisterApcError = 7;
        public const ushort RemoveIrqError = 8;
        public const ushort FindBoardError = 9;
        public const ushort ExceedBoardNumber = 10;
        public const ushort ResetError = 11;
        public const ushort EEPROMDataError = 12;
        public const ushort EEPROMWriteError = 13;
        public const ushort ActiveLow = 0;
        public const ushort ActiveHigh = 1;
        public const uint ID = 8389632;
        [DllImport("PIODA.dll", EntryPoint = "PIODA_ShortSub")]
        public static extern ushort ShortSub(ushort a, ushort b);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_FloatSub")]
        public static extern float FloatSub(float a, float b);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_GetDllVersion")]
        public static extern ushort GetDllVersion();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_DriverInit")]
        public static extern ushort DriverInit();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_DriverClose")]
        public static extern void DriverClose();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_SearchCard")]
        public static extern ushort SearchCard(out ushort wBoards, uint dwPIOPISOCardID);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_GetDriverVersion")]
        public static extern ushort GetDriverVersion(ref ushort wDriverVersion);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_GetConfigAddressSpace")]
        public static extern ushort GetConfigAddressSpace(ushort wBoardNo, out uint wAddrBase, out ushort wIrqNo, out ushort wSubVendor, out ushort wSubDevice, out ushort wSubAux, out ushort wSlotBus, out ushort wSlotDevice);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_ActiveBoard")]
        public static extern ushort ActiveBoard(ushort wBoardNo);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_WhichBoardActive")]
        public static extern ushort WhichBoardActive();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_SetCounter")]
        public static extern uint SetCounter(ushort wBoardNo, ushort wWhichCounter, ushort bConfig, uint wValue);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_GetBaseAddress")]
        public static extern uint GetBaseAddress(ushort wBoardNo);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_EEP_READ")]
        public static extern ushort EEP_READ(ushort wBoardNo, ushort wOffset, out ushort bHi, out ushort bLo);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_EEP_WR_EN")]
        public static extern ushort EEP_WR_EN(ushort wBoardNo);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_EEP_WR_DIS")]
        public static extern ushort EEP_WR_DIS(ushort wBoardNo);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_EEP_WRITE")]
        public static extern ushort EEP_WRITE(ushort wBoardNo, ushort wOffset, ushort HI, ushort LO);

        // DA functions
        //The D/A output for the PIODA_Voltage and PIODA_Current function is none calibration function
        //[DllImport("PIODA.dll", EntryPoint = "PIODA_Voltage")]
        //public static extern ushort Voltage(ushort wBoardNo, ushort wChannel, float fValue);

        //[DllImport("PIODA.dll", EntryPoint = "PIODA_Current")]
        //public static extern ushort Current(ushort wBoardNo, ushort wChannel, float fValue);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_CalVoltage")]
        public static extern ushort CalVoltage(ushort wBoardNo, ushort wChannel, float fValue);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_CalCurrent")]
        public static extern ushort CalCurrent(ushort wBoardNo, ushort wChannel, float fValue);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_OutputByte")]
        public static extern void OutputByte(uint wBaseAddress, ushort dataout);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_OutputWord")]
        public static extern void OutputWord(uint wBaseAddress, uint dataout);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_InputByte")]
        public static extern ushort InputByte(uint wBaseAddress);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_InputWord")]
        public static extern uint InputWord(uint wBaseAddress);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_DI")]
        public static extern ushort DI(ushort wBoardNo, out uint wVal);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_DO")]
        public static extern ushort DO(ushort wBoardNo, uint wDO);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_IntInstall")]
        public static extern ushort IntInstall(ushort wBoard, out uint hEvent, ushort wInterruptSource, ushort wActiveMode);

        [DllImport("PIODA.dll", EntryPoint = "PIODA_IntRemove")]
        public static extern ushort IntRemove();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_IntResetCount")]
        public static extern ushort IntResetCount();

        [DllImport("PIODA.dll", EntryPoint = "PIODA_IntGetCount")]
        public static extern ushort IntGetCount(out uint dwIntCount);


        private int DriverOpened = 0;

   


        public PIODA()//constroctor
        {
            DriverOpened = 0;
        }
        ~PIODA()
        {
            if (DriverOpened != 0)
            {
                DriverOpened = 0;
                DriverClose();
            }
        }
    }
}