
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    eTotalBoards: TEdit;
    eSelectBoard: TEdit;
    UpDown1: TUpDown;
    Label31: TLabel;
    cbCardType: TComboBox;
    GroupBox2: TGroupBox;
    cbVoltCur: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    eOut: TEdit;
    lDesc: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbVoltCurChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses PIODA;

{$R *.DFM}

Var
    wInitialCode,  wRtn             : Word;
    wTotalBoards                    : Word;
    wSelectBoard                    : Word;

procedure TForm1.Button1Click(Sender: TObject);
var
    fVal    : Single;
    i       : integer;
    wTtlChs : integer;
begin

    wSelectBoard := StrToInt( eSelectBoard.Text );
    wTtlChs := 4;  // PIO-DA4
    if cbCardType.ItemIndex = 1 then wTtlChs := 8;  // PIO-DA8
    if cbCardType.ItemIndex = 2 then wTtlChs := 16; // PIO-DA16

    fVal := StrToFloat( eOut.Text );
    for i:=0 to wTtlChs -1  do  // Every Channels
    begin
      if cbVoltCur.ItemIndex = 0 then // 0: Voltage Output
          PIODA_CalVoltage( wSelectBoard, WORD(i), fVal )
      else                            // 1: Current Output
          PIODA_CalCurrent( wSelectBoard, WORD(i), fVal );

    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

    wTotalBoards            := 0 ;
    Button1.Caption         := 'Output';
    cbCardType.ItemIndex    := 2;  // 2:PIO-DA16
    cbVoltCur.ItemIndex     := 0;  // 0:Voltage Output
    wInitialCode := PIODA_DriverInit();
    if ( wInitialCode <> PIODA_NoError ) then
    begin
        ShowMessage( 'Driver Initialize Error!!') ;
        Button1.Enabled := False;
        exit;
    end
    else
        Button1.Enabled := True;

    wRtn := PIODA_SearchCard( wTotalBoards, PIO_DA );
    if ( wRtn <> PIODA_NoError ) then
    begin
        ShowMessage( 'Search Card Error!!' + #13 + 'Error Code:' + IntToStr(wRtn) );
        Button1.Enabled := False;
    end;

    eSelectBoard.Text := '0';
    eTotalBoards.Text := IntToStr(wTotalBoards);
    Updown1.Max := wTotalBoards - 1;
    Updown1.Min := 0;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     PIODA_DriverClose();
end;








procedure TForm1.cbVoltCurChange(Sender: TObject);
begin
     if cbVoltCur.ItemIndex = 0 then
          lDesc.Caption := '(+/- 10v)'
     else
          lDesc.Caption := '(0~20mA)';
end;

end.
