Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
	Dim wInitialCode As Short
	Dim wRtn As Short
	Dim wSet, wTotalBoards As Short
    Dim wSelectBoard As Short
    Dim wTtlChs As Short
	

	Private Sub cbVoltCur_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbVoltCur.SelectedIndexChanged
		If cbVoltCur.SelectedIndex = 0 Then
			lDesc.Text = "(+/- 10v)"
		Else
			lDesc.Text = "(0~20mA)"
		End If
	End Sub


    Private Sub btnActive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActive.Click

        Dim i As Short
        Dim fVal As Single

        wSelectBoard = Val(eSelectBoard.Text)

        fVal = Val(eOut.Text)
        For i = 0 To wTtlChs - 1 ' Every Channels
            If cbVoltCur.SelectedIndex = 0 Then ' 0: Voltage Output
                PIODA_CalVoltage(wSelectBoard, cbxChannel.SelectedIndex, fVal)
            Else ' 1: Current Output
                PIODA_CalCurrent(wSelectBoard, cbxChannel.SelectedIndex, fVal)
            End If
        Next
        If cbVoltCur.SelectedIndex = 0 Then
            ToolTip1.ToolTipTitle = "How to measure the DA(Voltage) value ?"
            ToolTip1.Show("(+) connect with CN3.pin" + Str(1 + cbxChannel.SelectedIndex + cbxChannel.SelectedIndex \ 4) + ",GND(-) connect with CN3.pin10", Me.btnActive, 40, 40)
        Else
            Dim curPin As Short
            If cbxChannel.SelectedIndex < 8 Then
                curPin = 20 + cbxChannel.SelectedIndex + cbxChannel.SelectedIndex \ 4
            Else
                curPin = cbxChannel.SelectedIndex + 22
            End If
            ToolTip1.ToolTipTitle = "How to measure the DA(Current) value ?"
            ToolTip1.Show("(+) connect with CN3.pin" + Str(curPin) + ",GND(-) connect with CN3.pin29", Me.btnActive, 40, 40)

        End If
    End Sub

    Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load


        '********************************************************************
        '* NOTICE: call PIODA_DriverInit() to initialize the driver.        *
        '* Initial the device driver, and return the board number in the PC *
        '********************************************************************
        wTotalBoards = 0
        btnActive.Text = "Output"
        cbCardType.SelectedIndex = 2 ' 2:PIO-DA16
        cbVoltCur.SelectedIndex = 0 ' 0:Voltage Output
        wInitialCode = PIODA_DriverInit()
        If wInitialCode <> PIODA_NoError Then
            wRtn = MsgBox("Driver Open Error !!!")
            btnActive.Enabled = False
            Exit Sub
        Else
            btnActive.Enabled = True
        End If

        wRtn = PIODA_SearchCard(wTotalBoards, PIO_DA)
        If (wRtn <> PIODA_NoError) Then
            MsgBox("Search Card Error!!" & Chr(13) & "Error Code:" & Str(wRtn))
            btnActive.Enabled = False
        End If

        eTotalBoards.Text = CStr(wTotalBoards)
        nudActive.Minimum = 0
        nudActive.Maximum = wTotalBoards - 1
        Me.eSelectBoard.Text = Str(nudActive.Value)

        

        cbxChannel.SelectedIndex = 0

        tbxBaseAddr.Text = Hex(PIODA_GetBaseAddress(wSelectBoard))


    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        PIODA_DriverClose()
        End
    End Sub

    Private Sub cbCardType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbCardType.SelectedIndexChanged

        Dim j As Short

        If cbCardType.SelectedIndex = 0 Then wTtlChs = 4 ' PIO-DA4
        If cbCardType.SelectedIndex = 1 Then wTtlChs = 8 ' PIO-DA8
        If cbCardType.SelectedIndex = 2 Then wTtlChs = 16 ' PIO-DA16
        cbxChannel.Items.Clear()
        For j = 0 To wTtlChs - 1
            cbxChannel.Items.Add("Channel " + Str(j))
        Next

        cbxChannel.SelectedIndex = 0
    End Sub

    Private Sub btnActive_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnActive.GotFocus
        
    End Sub
End Class