Option Strict Off
Option Explicit On
Module PIODA
	
	Public Const PIODA_NoError As Short = 0
	Public Const PIODA_DriverOpenError As Short = 1
	Public Const PIODA_DriverNoOpen As Short = 2
	Public Const PIODA_GetDriverVersionError As Short = 3
	Public Const PIODA_InstallIrqError As Short = 4
	Public Const PIODA_ClearIntCountError As Short = 5
	Public Const PIODA_GetIntCountError As Short = 6
	Public Const PIODA_RegisterApcError As Short = 7
	Public Const PIODA_RemoveIrqError As Short = 8
	Public Const PIODA_FindBoardError As Short = 9
	Public Const PIODA_ExceedBoardNumber As Short = 10
	Public Const PIODA_ResetError As Short = 11
	
	Public Const PIODA_EEPROMDataError As Short = 12
	Public Const PIODA_EEPROMWriteError As Short = 13
	
	
	' to trigger a interrupt when high -> low
	Public Const PIODA_ActiveLow As Short = 0
	' to trigger a interrupt when low -> high
	Public Const PIODA_ActiveHigh As Short = 1
	
	
	' ID
	Public Const PIO_DA As Integer = &H800400 ' PIO-DA16/DA8/DA4
	
	
	' The Test functions
	Declare Function PIODA_ShortSub Lib "PIODA.dll" (ByVal a As Short, ByVal b As Short) As Short
	Declare Function PIODA_FloatSub Lib "PIODA.dll" (ByVal a As Single, ByVal b As Single) As Single
	Declare Function PIODA_GetDllVersion Lib "PIODA.dll" () As Short
	
	' The Driver functions
	Declare Function PIODA_DriverInit Lib "PIODA.dll" () As Short
	Declare Sub PIODA_DriverClose Lib "PIODA.dll" ()
	Declare Function PIODA_SearchCard Lib "PIODA.dll" (ByRef wBoards As Short, ByVal dwPIOPISOCardID As Integer) As Short
	Declare Function PIODA_GetDriverVersion Lib "PIODA.dll" (ByRef wDriverVersion As Short) As Short
	Declare Function PIODA_GetConfigAddressSpace Lib "PIODA.dll" (ByVal wBoardNo As Short, ByRef wAddrBase As Integer, ByRef wIrqNo As Short, ByRef wSubVendor As Short, ByRef wSubDevice As Short, ByRef wSubAux As Short, ByRef wSlotBus As Short, ByRef wSlotDevice As Short) As Short
	
	Declare Function PIODA_ActiveBoard Lib "PIODA.dll" (ByVal wBoardNo As Short) As Short
	Declare Function PIODA_WhichBoardActive Lib "PIODA.dll" () As Short
	Declare Function PIODA_SetCounter Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wWhichCounter As Short, ByVal bConfig As Short, ByVal wValue As Integer) As Integer
	Declare Function PIODA_GetBaseAddress Lib "PIODA.dll" (ByVal wBoardNo As Short) As Integer
	
	' EEPROM functions
	Declare Function PIODA_EEP_READ Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wOffset As Short, ByRef bHi As Short, ByRef bLo As Short) As Short
	Declare Function PIODA_EEP_WR_EN Lib "PIODA.dll" (ByVal wBoardNo As Short) As Short
	Declare Function PIODA_EEP_WR_DIS Lib "PIODA.dll" (ByVal wBoardNo As Short) As Short
	Declare Function PIODA_EEP_WRITE Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wOffset As Short, ByVal HI As Short, ByVal LO As Short) As Short
	
	' DA functions
	'The D/A output for the PIODA_Voltage and PIODA_Current function is none calibration function
	'Declare Function PIODA_Voltage Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wChannel As Short, ByVal fValue As Single) As Short
	'Declare Function PIODA_Current Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wChannel As Short, ByVal fValue As Single) As Short
	Declare Function PIODA_CalVoltage Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wChannel As Short, ByVal fValue As Single) As Short
	Declare Function PIODA_CalCurrent Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wChannel As Short, ByVal fValue As Single) As Short
	
	' DIO functions
	Declare Sub PIODA_OutputByte Lib "PIODA.dll" (ByVal wBaseAddress As Integer, ByVal dataout As Short)
	Declare Sub PIODA_OutputWord Lib "PIODA.dll" (ByVal wBaseAddress As Integer, ByVal dataout As Integer)
	Declare Function PIODA_InputByte Lib "PIODA.dll" (ByVal wBaseAddress As Integer) As Short
	Declare Function PIODA_InputWord Lib "PIODA.dll" (ByVal wBaseAddress As Integer) As Integer
	Declare Function PIODA_DI Lib "PIODA.dll" (ByVal wBoardNo As Short, ByRef wVal As Integer) As Short
	Declare Function PIODA_DO Lib "PIODA.dll" (ByVal wBoardNo As Short, ByVal wDO As Integer) As Short
	
	' Interrupt functions
	Declare Function PIODA_IntInstall Lib "PIODA.dll" (ByVal wBoard As Short, ByRef hEvent As Integer, ByVal wInterruptSource As Short, ByVal wActiveMode As Short) As Short
	Declare Function PIODA_IntRemove Lib "PIODA.dll" () As Short
	Declare Function PIODA_IntResetCount Lib "PIODA.dll" () As Short
	Declare Function PIODA_IntGetCount Lib "PIODA.dll" (ByRef dwIntCount As Integer) As Short
End Module