VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00808000&
   Caption         =   "Interrupt Demo for PIO-DA16/DA8/DA4"
   ClientHeight    =   5304
   ClientLeft      =   2184
   ClientTop       =   2376
   ClientWidth     =   6900
   LinkTopic       =   "Form1"
   ScaleHeight     =   5304
   ScaleWidth      =   6900
   Begin VB.ListBox List1 
      BackColor       =   &H00C0FFFF&
      Height          =   3888
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":000A
      TabIndex        =   7
      Top             =   720
      Width           =   6612
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Exit"
      Height          =   492
      Left            =   4920
      TabIndex        =   6
      Top             =   4680
      Width           =   1812
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   492
      Left            =   120
      TabIndex        =   3
      Top             =   4680
      Width           =   1812
   End
   Begin VB.TextBox eTotalBoards 
      Alignment       =   1  'Right Justify
      BackColor       =   &H00C0FFFF&
      Enabled         =   0   'False
      Height          =   288
      Left            =   1800
      TabIndex        =   2
      Text            =   "0"
      Top             =   240
      Width           =   972
   End
   Begin VB.TextBox eSelectBoard 
      Alignment       =   1  'Right Justify
      BackColor       =   &H0080FF80&
      Height          =   372
      Left            =   5520
      TabIndex        =   1
      Text            =   "0"
      Top             =   240
      Width           =   972
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   372
      Left            =   6480
      TabIndex        =   0
      Top             =   240
      Width           =   252
   End
   Begin VB.Label Label14 
      BackColor       =   &H00808000&
      Caption         =   "Choose a Board Number to Active"
      ForeColor       =   &H00FFFFFF&
      Height          =   372
      Left            =   4080
      TabIndex        =   5
      Top             =   240
      Width           =   1332
   End
   Begin VB.Label Label1 
      BackColor       =   &H00808000&
      Caption         =   "Total Boards : "
      ForeColor       =   &H00FFFFFF&
      Height          =   252
      Left            =   600
      TabIndex        =   4
      Top             =   240
      Width           =   1092
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'/******************************************************************************/
'/* For the proper operation the PIODA, the following functions must be used. */
'/*    PIODA_DriverInit()     <--   initial the driver                        */
'/*    PIODA_DriverClose()    <--   close the driver                          */
'/******************************************************************************/

Option Explicit
Dim wBase As Long
Dim wTotalBoards, wInitialCode As Integer
Dim dwIntCount As Long
Dim hEvent As Long


Private Sub Command1_Click()
     Dim wRetVal As Integer
     Dim wSelectBoard As Integer
     Dim i As Integer
     Dim lRtn As Long
    
     If Command1.Caption = "Stop" Then
         Command1.Caption = "Active"
         Command2.Enabled = True
         Exit Sub
     End If
    
     List1.Clear

     wSelectBoard = Val(eSelectBoard.Text)
     If wSelectBoard > Val(eTotalBoards.Text) - 1 _
     Or wSelectBoard < 0 Then
         List1.AddItem "Invalid board number, Pls retry!!"
         Exit Sub
     End If

     wBase = PIODA_GetBaseAddress(wSelectBoard)
     If wBase = 0 Then
         List1.AddItem "Get Base-Address Error !!"
         Exit Sub
     End If
    
     PIODA_IntResetCount
     
     dwIntCount = 0
     hEvent = CreateEvent(0, False, False, 0)
     If hEvent = 0 Then
        List1.AddItem "Create Event Error!!"
        Exit Sub
     Else
        List1.AddItem "Create Event OK!!"
     End If
     
     INT0InitialHigh wSelectBoard, wBase, &H36, 20000
     'INT1InitialHigh  wSelectBoard, wBase, &h76, 400, &hb6, 100

     '// Initial High and Active Low
     '// The Interrupt-Source can be:
     '//         0: INT0
     '//         1: INT1
     wRetVal = PIODA_IntInstall(wSelectBoard, hEvent, 0, PIODA_ActiveLow)
     If wRetVal <> PIODA_NoError Then
        List1.AddItem "Interrupt Install Error!!"
        List1.AddItem "Close Event"
        CloseHandle hEvent
        Exit Sub
     Else
        List1.AddItem "Interrupt Install OK!!"
     End If

     Command1.Caption = "Stop"
     Command2.Enabled = False
     List1.AddItem "  "
     List1.AddItem "Click the button 'Stop' to stop!"
     DoEvents

     Do While (True)
        List1.AddItem "   Wait Event ....."
        DoEvents
        lRtn = WaitForSingleObject(hEvent, INFINITE)
        List1.AddItem "   Got Event !!"
        DoEvents
        '***** Do some thing in here ****
        '   :
        '   :
        '   :
        List1.AddItem "  "
        DoEvents
        If Command1.Caption = "Active" Then
            Exit Do
        End If
     Loop

     List1.AddItem " "

     '// Revmove the Interrupt
     PIODA_IntRemove
     List1.AddItem "Stop Interrupt!!"
     CloseHandle hEvent

     '// How many times the interrupt occur
     wRetVal = PIODA_IntGetCount(dwIntCount)
     If wRetVal <> PIODA_NoError Then
        List1.AddItem "Get Interrupt Counter Error!!"
     Else
        List1.AddItem "Interrupt Counter:" + Str(dwIntCount)
     End If

     List1.AddItem "end"
End Sub


Private Sub Command2_Click()
    End
End Sub

Private Sub Form_Load()
    Dim rtn
    
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 2
    
    '********************************************************************
    '* NOTICE: call PIODA_DriverInit() to initialize the driver.        *
    '* Initial the device driver, and return the board number in the PC *
    '********************************************************************
    wInitialCode = PIODA_DriverInit()
    Command1.Caption = "Active"
    eSelectBoard.Text = 0
    If wInitialCode <> PIODA_NoError Then
        rtn = MsgBox("Driver initialize error!!!", , "PIODA Card Error")
        Command1.Enabled = False
        Exit Sub
    End If
    
    If PIODA_SearchCard(wTotalBoards, PIO_DA) <> PIODA_NoError Then
        rtn = MsgBox("Search Card Error!!", , "PIODA Card Error")
        Command1.Enabled = False
    Else
        Command1.Enabled = True
    End If
    
    eTotalBoards.Text = wTotalBoards
    VScroll1.Min = wTotalBoards - 1
    VScroll1.Max = 0
    VScroll1.Value = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
        PIODA_DriverClose
End Sub

Private Sub VScroll1_Change()
    eSelectBoard.Text = VScroll1.Value
End Sub


' ******************************************************************
' Initialize the INT0 Interrupt to High
' this will uses the Counter0 to trigger the interrupt.
'
' Parameters :
'   wBoardNo        :[in] Board Number, Range is 0 to 7.
'   wCounter0Config :[in] The configuration code of Counter0
'   wCounter0Value  :[in] 0 to &hFFFF, the value is used to set the Counter0
'                         Only the low Word (16-bits) is valid.
' ******************************************************************
Sub INT0InitialHigh(ByVal wBoardNo As Integer, ByVal wBase As Long, _
         ByVal wCounter0Config As Integer, _
         ByVal wCounter0Value As Long)
    ' Cout0 as 4Mhz/ wCounter0Value
    ' Counter 0
    PIODA_SetCounter wBoardNo, 0, wCounter0Config, wCounter0Value

    ' wait for Cout0 to high
    While (True)
      If ((PIODA_InputByte(wBase + &H7) And 1) <> 0) Then
          Exit Sub
      End If
    Wend
End Sub

' ******************************************************************
' Initialize the INT1 Interrupt to High,
' this will uses the Counter1 and Counter2 to trigger the interrupt.
'
' Parameters :
'   wBoardNo        :[in] Board Number, Range is 0 to 7.
'   wCounter1Config :[in] The configuration code of Counter1
'   wCounter1Value  :[in] 0 to &hFFFF, the value is used to set the Counter1
'                         Only the low Word (16-bits) is valid.
'   wCounter2Config :[in] The configuration code of Counter2
'   wCounter2Value  :[in] 0 to &hFFFF, the value is used to set the Counter2
'                         Only the low Word (16-bits) is valid.
' ******************************************************************
Sub INT1InitialHigh(ByVal wBoardNo As Integer, ByVal wBase As Long, _
         ByVal wCounter1Config As Integer, ByVal wCounter1Value As Long, _
         ByVal wCounter2Config As Integer, ByVal wCounter2Value As Long)
   ' Cout2 as 4Mhz/( wCounter1Value * wCounter2Value)
   ' Counter 1
   PIODA_SetCounter wBoardNo, 1, wCounter1Config, wCounter1Value
   'Counter 2
   PIODA_SetCounter wBoardNo, 2, wCounter2Config, wCounter2Value

   ' wait for Cout2 to high
   While (True)
      If ((PIODA_InputByte(wBase + &H7) And 3) <> 0) Then
          Exit Sub
      End If
   Wend
End Sub


