//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop

#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "CSPIN"
#pragma link "PIODAXLib_OCX"
#pragma resource "*.dfm"

Word wInitialCode,  wRtn ;
Word wTotalBoards;
Word wSelectBoard;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    float fVal;
    int   i, wTtlChs;

    wSelectBoard = (WORD) StrToInt( eSelectBoard->Text );
    if (cbCardType->ItemIndex == 0) wTtlChs = 4;  // PIO-DA4
    if (cbCardType->ItemIndex == 1) wTtlChs = 8;  // PIO-DA8
    if (cbCardType->ItemIndex == 2) wTtlChs = 16; // PIO-DA16

    fVal= StrToFloat( eOut->Text );
    for(i=0; i< wTtlChs; i++)  // Every Channels
    {
           if (cbVoltCur->ItemIndex == 0)  // 0: Voltage Output
               PIODAX1->OutCalVoltage( (Word)i, fVal );
           else                            // 1: Current Output
               PIODAX1->OutCalCurrent( (Word)i, fVal );

    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //********************************************************************
    //* NOTICE: call PIODA_DriverInit() to initialize the driver.        *
    //********************************************************************

    wTotalBoards             = 0;
    cbCardType->ItemIndex    = 2;  // 2:PIO-DA16
    cbVoltCur->ItemIndex     = 0;  // 0:Voltage Output
    Button1->Caption         = "Output";
    wTotalBoards = PIODAX1->DriverInit();
        Button1->Enabled = True;


    eSelectBoard->Text  = "0";
    eTotalBoards->Text  = IntToStr(wTotalBoards);
    if ( wTotalBoards < 2 ) eSelectBoard->Enabled = False;
    eSelectBoard->MaxValue = wTotalBoards - 1;
    eSelectBoard->MinValue = 0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
      PIODAX1->DriverClose();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button2Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::cbVoltCurChange(TObject *Sender)
{
     if ( cbVoltCur->ItemIndex == 0)
          lDesc->Caption = "(+/- 10v)";
     else
          lDesc->Caption = "(0~20mA)";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PIODAX1Error(TObject *Sender, short lErrorCode)
{
ShowMessage("Error Code:" + IntToStr(lErrorCode)+"\n"+ "Error Message :" + PIODAX1->ErrorString);     
}
//---------------------------------------------------------------------------

