
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, OleCtrls, PIODAXLib_TLB;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    eTotalBoards: TEdit;
    eSelectBoard: TEdit;
    UpDown1: TUpDown;
    Label31: TLabel;
    cbCardType: TComboBox;
    GroupBox2: TGroupBox;
    cbVoltCur: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    eOut: TEdit;
    lDesc: TLabel;
    PIODAX1: TPIODAX;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbVoltCurChange(Sender: TObject);
    procedure PIODAX1Error(Sender: TObject; lErrorCode: Smallint);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Var
    wTotalBoards                    : Word;
    wSelectBoard                    : Word;

procedure TForm1.Button1Click(Sender: TObject);
var
    fVal    : Single;
    i       : integer;
    wTtlChs : integer;          
begin

    wSelectBoard := StrToInt( eSelectBoard.Text );
    piodax1.ActiveBoard := wSelectBoard;
    wTtlChs := 4;  // PIO-DA4
    if cbCardType.ItemIndex = 1 then wTtlChs := 8;  // PIO-DA8
    if cbCardType.ItemIndex = 2 then wTtlChs := 16; // PIO-DA16

    fVal := StrToFloat( eOut.Text );
    for i:=0 to wTtlChs -1  do  // Every Channels
      begin
           if cbVoltCur.ItemIndex = 0 then // 0: Voltage Output
               PIODAX1.OutCalVoltage( WORD(i), fVal )
           else                            // 1: Current Output
               PIODAX1.OutCalCurrent(  WORD(i), fVal );

      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

    wTotalBoards            := 0 ;
    Button1.Caption         := 'Output';
    cbCardType.ItemIndex    := 2;  // 2:PIO-DA16
    cbVoltCur.ItemIndex     := 0;  // 0:Voltage Output
    PIODAX1.DriverInit();
    Button1.Enabled := True;

    wTotalBoards:=PIODAX1.DriverInit ;

    eSelectBoard.Text := '0';
    eTotalBoards.Text := IntToStr(wTotalBoards);
    Updown1.Max := wTotalBoards - 1;
    Updown1.Min := 0;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     PIODAX1.DriverClose();
end;








procedure TForm1.cbVoltCurChange(Sender: TObject);
begin
     if cbVoltCur.ItemIndex = 0 then
          lDesc.Caption := '(+/- 10v)'
     else
          lDesc.Caption := '(0~20mA)';
end;

procedure TForm1.PIODAX1Error(Sender: TObject; lErrorCode: Smallint);
begin
ShowMessage('Error Code:' + IntToStr(lErrorCode)+#13+ 'Error Message :' + PIODAX1.ErrorString);
end;

end.
